#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Feb 15 08:18:45 2019

@author: stan
"""
from itertools import product
from boolparse.formula_parser import FormulaParser as parser

class TruthTable:
    """
    Tabla de verdad
    """
    
    def __init__(self,variables,name,values=None,formula=None,formulastr=None):
        self.n = len(variables)
        self.values = values
        self.name = name
        self.variables = variables
        self.formula = formula
        self.formulastr = formulastr
        t = [False,True]
        g = (t for _ in range(self.n))
        left = product(*g)
        if values:
            self.table = {k:v for k,v in zip(left,values)}
        else:
            self.table = {}
            for tupla in left:
                assignment = {var:val for var,val in zip(variables,tupla)}
                self.table[tupla]=formula.evaluate(assignment)
                
        
    def __getitem__(self,estado):
        return self.table[estado]
    
    def __str__(self):
        s = "\n"
        sep = " "        
        encabezado = sep.join(self.variables)+ sep+"\\"+sep + self.name + "\n"
        encabezado += "-"*len(encabezado) + "\n"
        s += encabezado
        for tupla in sorted(self.table.items()):
            l = ""
            izq,der = tupla
            l += sep.join("1" if i else "0" for i in izq)
            l += sep+"\\"+sep
            l += "1" if der else "0"
            l += "\n"
            s += l
        return s
    
    def __repr__(self):
        return str(self)
    
    
    @staticmethod
    def from_formula(formula,name):
        ftree,variables = parser.parse(formula)
        return TruthTable(variables,name,formula=ftree,formulastr=formula)
        
